; GUI #
; OpenGl Examples->02-OpenGL Viewing and Transformations
include win64a.inc
; --------------- 
WINDOWWIDTH  = 600
WINDOWHEIGHT = 450

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	alpha:DWORD
local	scale:DWORD

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC   ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax; 
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
        invoke	SetTimer,hWin,10,50,0;  #10  50mSec
	invoke  glEnable,GL_DEPTH_TEST
	invoke  glShadeModel, GL_FLAT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
;GetTickCount()/10.0
        invoke  GetTickCount
	mov	alpha,eax
	fild	alpha
	fld	const0_1
	fmulp
	fstp	alpha
;sinf(GetTickCount()/1000.0f)+1.1
	invoke	GetTickCount
	mov	scale, eax
	fild	scale
	fld	const0_001
	fmulp
	fsin
	fld	const1_1
	faddp
	fstp	scale

	invoke	glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke  glLoadIdentity
        movd    xmm0,ebx
        movd    xmm1,ebx
        movd	xmm2,const_4
	invoke  glTranslatef
;         glPushMatrix(), 
;   
	invoke  glPushMatrix
	mov	eax,const_2
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,ebx
	invoke  glTranslatef
        movd    xmm0,alpha
        movd	xmm1,const1
        movd	xmm2,const0_5
        movd    xmm3,ebx
	call    DrawCube

	invoke  glPushMatrix
        movd	xmm0,const2
        movd	xmm1,const_2
        movd    xmm2,ebx
	invoke  glTranslatef
        movd    xmm0,alpha
        movd	xmm1,const1
        movd	xmm2,const_0_5
        movd	xmm3,const0_5
	call    DrawCube

	invoke  glPushMatrix
	mov	eax,const2
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,ebx
	invoke  glTranslatef
        movd    xmm0,alpha
        movd    xmm1,ebx
        movd	xmm2,const0_5
        movd	xmm3,const_1
	call    DrawCube

	invoke  glPushMatrix

        movd	xmm0,const_2
        movd	xmm1,const2
        movd    xmm2,ebx
	invoke  glTranslatef
        movd    xmm0,alpha
	mov	eax,const1
        movd	xmm1,eax
        movd    xmm3,eax
        movd	xmm2,const_0_5
	call    DrawCube

	invoke  glPushMatrix
	mov	eax,scale
        movd    xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glScalef
        movd    xmm0,alpha
        movd	xmm1,const_0_5
        movd	xmm2,const1
        movd    xmm3,ebx
	call    DrawCube
;   
	invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp
DrawCube proc 
	enter 20h,0
	invoke  glRotatef
     ;Colorful Quad
	invoke  glBegin, GL_QUAD_STRIP
;  
        movd	xmm0,const1
        movd    xmm1,ebx
        movd    xmm2,ebx
	invoke  glColor3f
	mov	eax,const_0_5
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
        movd	xmm0,const0_5
	mov	eax,const_0_5
        movd	xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const1
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,ebx
	invoke  glColor3f
	mov	eax,const_0_5
        movd	xmm0,eax
        movd    xmm2,eax
        movd	xmm1,const0_5
        invoke  glVertex3f
	mov	eax,const0_5
        movd	xmm0,eax
        movd    xmm1,eax
        movd	xmm2,const_0_5
	invoke  glVertex3f
        movd    xmm0,ebx
        movd    xmm2,ebx
        movd	xmm1,const1
	invoke  glColor3f
        movd	xmm0,const_0_5
	mov	eax,const0_5
        movd	xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const0_5
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
        movd    xmm0,ebx
	mov	eax,const1
        movd	xmm1,eax
        movd    xmm2,eax
	invoke  glColor3f
	mov	eax,const_0_5
        movd	xmm0,eax
        movd    xmm1,eax
        movd	xmm2,const0_5
	invoke  glVertex3f
	mov	eax,const0_5
        movd	xmm0,eax
        movd    xmm2,eax
        movd	xmm1,const_0_5
	invoke  glVertex3f
	mov	eax,const1
        movd	xmm0,eax
        movd    xmm2,eax
        movd    xmm1,ebx
	invoke  glColor3f
	mov	eax,const_0_5
        movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
        movd	xmm0,const0_5
	mov	eax,const_0_5
        movd	xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	invoke  glEnd
        movd    xmm0,ebx
        movd    xmm1,ebx
	movd	xmm2,const1
	invoke  glColor3f
	invoke  glBegin, GL_QUADS
	mov	eax,const_0_5
	movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const_0_5
	movd	xmm0,eax
        movd    xmm2,eax
	movd	xmm1,const0_5
	invoke  glVertex3f
	movd	xmm0,const_0_5
	mov	eax,const0_5
	movd	xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const_0_5
	movd	xmm0,eax
        movd    xmm1,eax
	movd	xmm2,const0_5
	invoke  glVertex3f
	movd	xmm0,const0_5
	mov	eax,const_0_5
	movd	xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const0_5
	movd	xmm0,eax
        movd    xmm1,eax
	movd	xmm2,const_0_5
	invoke  glVertex3f
	mov	eax,const0_5
	movd	xmm0,eax
        movd    xmm1,eax
        movd    xmm2,eax
	invoke  glVertex3f
	mov	eax,const0_5
	movd	xmm0,eax
        movd    xmm2,eax
	movd	xmm1,const_0_5
	invoke  glVertex3f
	invoke  glEnd

	invoke  glMatrixMode, GL_PROJECTION
	invoke  glLoadIdentity
	movq	xmm0,constd90
	movq	xmm1,constd1_3
	movq	xmm2,constd0_1
	movq	xmm3,constd1000
	invoke  gluPerspective
	invoke  glMatrixMode, GL_MODELVIEW
	invoke  glPopMatrix;  
	leave
	retn
DrawCube endp
;------.data--------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  
szClassName	db "Uncle Remus tales:#40 OpenGL",0
FileName	db "br_Rabbit3.cur",0
;float
const0_001	dd 0.001
const0_1	dd 0.1
const0_5	dd 0.5
const_0_5	dd -0.5
const1		dd 1.0
const_1		dd -1.0
const1_1	dd 1.1
const2		dd 2.0
const_2		dd -2.0
const_4		dd -4.0
;double
constd0_1	dq 0.1
constd1_3	dq 1.3
constd90	dq 90.0
constd1000	dq 1000.0
end